//***************
//* TP4 : Piles *
//***************

#include <iostream>
#include <stack>

using namespace std;
//******************
//* Structure Pile *
//******************

/* Une pile est un conteneur possedant 4 opérations
   push(x) permettant d'ajouter la valeur x en haut de la pile
   top() retournant la valeur du haut de la pile
   pop() retirant la valeur du haut de la pile
   empty() testant si la pile est vide ou pas */

typedef stack<int> PileEntier;
typedef stack<char> PileCharactere;

//************
// Exercice 1 
//************

// Le but de cet exercice est de résoudre le jeu des tours de Hanoï

/*1. Imaginer une structure Hanoi permettant de modéliser les tours de Hanoï avec PileEntier*/

/*2. Ecrire une fonction initiolisant une structure Hanoi avec n disque sur le
  premier piquet */

//void initialise(Hanoi& h,int n){}

/*3. Créer une fonction permettant d'afficher le statut des tours de Hanoï. */

//void affiche(Hanoi& h){}

/*4. Créer une fonction deplace(Hanoi& h,int d,int a) permettant de déplacer le
  disque de la tour d vers la tour a */

//void deplace(Hanoi& hnint d,int a){}

/* 5 Créer une fonction qui teste si les trours sont résolus (tous les disques sur le piquet 2. */

//bool estFini(Hanoi& H){}

/* 6 Ecrire une fonction décrivant pas à pas commant résoudre le problème des tours de Hanoï.*/

//void resoudre(Hanoi& h){}


//**************
//* Exercice 2 *
//**************

/* La notation polonaise inverse (ou notation post-fixée) permet d'écrire de
  facon non ambigue les formules arithmétiques sans utiliser de parenthèses.
  Le principe est qu'un opérateur binaire (+,-,*) soit écrit aprés ses arguments.
  L'opération 3+5 s'écrit donc "3 5 +"/
  Le but de cet exerecice est de créer une calculatrice utilsant la notation
  polonaise inverse. */

// 1. Représenter le calcul ((6+5)*9-8)+3 en notation polonaise

/* 2. Evaluer a la main les expressions suivantes. Les nombres ne contiennent
   tous qu'un seul chiffre.*/

string calc1="12+4*3+";
string calc2="3412+*+";
string calc3="56+23*-";
string calc4="743+2*-";


/* 3. Pour simplifier on supposera que les nombres n'auront qu'un seul chiffre
   (0,1,...,9) et que les opérateurs seront seulement '-','+','*'.
   A l'aide d'une pile écrire une fonction int evalue(string calc) prenant en entrée un calcul
   en notation polonoaise comme calc 1 et retourant le résultat.*/

//int evalue(string calc){}

//*****************
//* Fonction Main *
//*****************

int main(){
  //**********************************************************************
  //* Voici une liste utile pour tester votre fonction inverse avec pile *
  //**********************************************************************
  
  //Liste ( 2 5 8 3 2 4 )
  Liste l3;
  Element* e31=new Element;
  Element* e32=new Element;
  Element* e33=new Element;
  Element* e34=new Element;
  Element* e35=new Element;
  Element* e36=new Element;
  l3.tete=e31;
  e31->suivant=e32;
  e32->suivant=e33;
  e33->suivant=e34;
  e34->suivant=e35;
  e35->suivant=e36;
  e36->suivant=NULL;
  e31->valeur=2;
  e32->valeur=5;
  e33->valeur=8;
  e34->valeur=3;
  e35->valeur=2;
  e36->valeur=4;

  PileEntier P;
  P.push(5);
  P.push(6);
  cout<<P.top()<<endl;
  P.pop();
  cout<<P.top()<<endl;
  cout<<P.empty()<<endl;
}
